//
// $Id: MyRandom.cc,v 1.1 2000/10/12 19:52:39 min Exp $
//

#include <math.h>
#include "MyRandom.h"





Float
MyRandom::uniform(Float min, Float max)
{
  Float r = ((Float)(rand() % (RAND_MAX + 1))) / ((Float) RAND_MAX);
  return (min + r * (max - min));
}  // MyRandom::uniform



Float
MyRandom::gaussian()
{
  // from Numerical Recipes, paragraph 7.2
  Float v1, v2, length_sq;

  do {
    v1 = uniform(-1, 1);
    v2 = uniform(-1, 1);
    length_sq = v1*v1 + v2*v2;
  } while ((length_sq > 1) || (length_sq == 0));

  Float fac = sqrt((-2 * log(length_sq))/length_sq);

  return v2*fac;
}  // MyRandom::gaussian


