//
// $Id: PointSet2D.h,v 1.1 2004/02/25 10:44:57 min Exp $
//

#ifndef __PointSet2D_h
#define __PointSet2D_h

#include <vector>

using namespace std;





class PointSet2D
{

public:

  PointSet2D(int nr_points = DEFAULT_NR_POINTS);
  PointSet2D(PointSet2D& other);
  ~PointSet2D();


  void init(int nr_points = DEFAULT_NR_POINTS);
  void clear() { points.clear(); }
  
  void add_point(double x, double y) { points.push_back(x), points.push_back(y); }
  
  int get_nr_points() const { return points.size() / 2; }
  
  double& operator[](int index) { return points[index]; }
  double operator[](int index) const { return points[index]; }


  static const int DEFAULT_NR_POINTS = 50;

  
private:

  vector<double> points;

  
};  // PointSet2D class


#endif


