#ifndef __COMMON_H
#define __COMMON_H





typedef double Float;
typedef short Short;
typedef unsigned char byte;



#if WIN32

#include <float.h>
#include <limits.h>

const double MaxFloat = DBL_MAX;
const double MinFloat = DBL_MIN;
const double M_PI = 3.14159265358979323846;
const double M_E = 2.7182818284590452354;
const int MaxInt = INT_MAX;

//
// trick to make Windows accept ANSI for scoping rule
//
#define for if(0) ; else for

#else

#include <values.h>
const double MaxFloat = MAXDOUBLE;
const double MinFloat = MINDOUBLE;
const int MaxInt = MAXINT;


#endif


//
// qsort support function for Float
//
int compare(const void *a_ptr, const void *b_ptr);

#if (!LINUX || (__GNUC__ < 3))  // apparently mathcalls.h has 'round' now (in gcc 3.0)
int my_round(Float value);
#endif

unsigned short swap_byte_order(unsigned short n);

inline int minimum(int a, int b) { if (a < b) return a; else return b; }

Float delta_wrap(Float a, Float b, Float limit);
Float fix_angle(Float angle);
Float my_atan(Float dx, Float dy);


#endif


