//
// $Id$
//

#ifndef __Hausdorff_h
#define __Hausdorff_h

#include "data_types/PointSet2D.h"





class Hausdorff
{

public:

  Hausdorff();
  virtual ~Hausdorff() {}

  
  virtual double operator()(const PointSet2D& source, const PointSet2D& target);


  virtual string get_name() { return "Hausdorff"; }

  
protected:

  static const int MAXMIN = 0;
  static const int MAXMAX = 1;
  static const int AVGMIN = 2;
  static const int AVGMAX = 3;
  
  int distance_type;

  
private:

  double directed_hausdorff_distance(const PointSet2D& source, const PointSet2D& target);
  double hausdorff_distance(const PointSet2D& source, const PointSet2D& target);

  double maxmin, maxmax;
  double avgmin, avgmax;


};  // Hausdorff class


#endif


