//
// $Id$
//

#include <vector>
#include <iostream>
#include <fstream>
#include "data_types/common.h"

#include "traits/evo_traits_2d_iso_avg_hausdorff.h"
typedef evo_traits_2d_iso_avg_hausdorff evo_traits;
#include "lib/evo_par_default_traits.h"
#include "lib/EvoFunc.h"

template class EvoFunc<evo_traits_2d_iso_avg_hausdorff, evo_par_default_traits>;

evo_traits::SourceType source;
evo_traits::TargetType target;
evo_traits gt;
EvoFunc<evo_traits, evo_par_default_traits> evo_opt(source, target, gt);


using namespace std;







int main(int argc, char **argv)
{
  cout << endl;
  cout << "--------" << endl;
  cout << "example2" << endl;
  cout << "--------" << endl;
  cout << endl;

  //
  // we want to run each combination of 2 parameters across a 2D interval
  //
  // the transformation (map function) and error function are the same as in example1
  //
  // our transformation (2D isometry) has 3 parameters: tx, ty, angle
  //
  
  //
  // the map function constructor (in Map_2d_Iso.cc) initializes the parameter ranges
  //
  // EvoFunc::GRID_NR_STEPS controls the number of steps in each range
  //

  //
  // results are stored in a 2D array of doubles
  // here we don't do anything with the returned fitness_matrix
  //
  vector<vector<double> > fitness_matrix;

  //
  // the indices of the 2 parameters to run is stored in par_index
  //
  int par_index[2];
  
  //
  // because there are only 3 combinations, we can do them each in turn
  //
  // the resulting grids are written to files grid_01.dat, grid_02.dat, and grid_12.dat
  //
  par_index[0] = 0;
  par_index[1] = 1;
  evo_opt.run_2d_grid(par_index, fitness_matrix);

  par_index[0] = 0;
  par_index[1] = 2;
  evo_opt.run_2d_grid(par_index, fitness_matrix);

  par_index[0] = 1;
  par_index[1] = 2;
  evo_opt.run_2d_grid(par_index, fitness_matrix);

  cout << "done" << endl << endl;
  
}  // main

