//
// $Id: MyRandom.cc,v 1.1 2004/03/01 09:47:25 min Exp $
//

#include <math.h>
#include "MyRandom.h"





double
MyRandom::uniform(double min, double max)
{
  double r = ((double)(rand() % (RAND_MAX + 1))) / ((double) RAND_MAX);
  return (min + r * (max - min));
  
}  // MyRandom::uniform



double
MyRandom::gaussian()
{
  // from Numerical Recipes, paragraph 7.2
  double v1, v2, length_sq;

  do {
    v1 = uniform(-1, 1);
    v2 = uniform(-1, 1);
    length_sq = v1*v1 + v2*v2;
  } while ((length_sq > 1) || (length_sq == 0));

  double fac = sqrt((-2 * log(length_sq))/length_sq);

  return v2*fac;
  
}  // MyRandom::gaussian


