//
// $Id$
//

#include <iostream>
#include <fstream>
#include "Map.h"




  
Map::Map(Map& map)
{
  cout << "Map copy constructor" << endl;
  
  vector<double>& pars = map.get_parameters();
  parameters.clear();
  int nr_pars = pars.size();
  for(int i=0; i < nr_pars; i++) { parameters.push_back(pars[i]); }

  vector<double>& par_ranges = map.get_parameter_ranges();
  parameter_ranges.clear();
  int nr_ranges = par_ranges.size();
  for(int i=0; i < nr_ranges; i++) { parameter_ranges.push_back(par_ranges[i]); }

}  // copy constructor (!)



void
Map::init_parameter_ranges(double *ranges, int nr)
{
  //  cout << "Map::init_parameter_ranges" << endl;

  parameters.clear();
  parameter_ranges.clear();
  for(int i=0; i < nr; i += 2) {
    double min = ranges[i];
    double max = ranges[i + 1];
    parameter_ranges.push_back(min);
    parameter_ranges.push_back(max);
    double middle = (max - min) / 2.0 + min;
    parameters.push_back(middle);
  }  // for

  //  cout << "  copied " << nr << " ranges" << endl;

}  // Map::init_parameter_ranges



int
Map::init_parameter_ranges(string filespec)
{
  cout << "Map::init_parameter_ranges" << endl;
  
  ifstream ranges(filespec.c_str());

  if (!ranges.good()) {
    cout << "  error opening [" << filespec << "]" << endl;
    return 0;
  }

  parameter_ranges.clear();
  parameters.clear();
  
  int done = 0;
  string line;
  while(!done) {
    getline(ranges, line);
    double min = atof(line.c_str());
    getline(ranges, line);
    double max = atof(line.c_str());
    if (ranges.good()) {
      parameter_ranges.push_back(min);
      parameter_ranges.push_back(max);
      double middle = (max - min) / 2.0 + min;
      parameters.push_back(middle);
      cout << "  read [" << min << ", " << max << "]" << endl;
    }
    else {
      done = 1;
    }
  }
  ranges.close();

  cout << "  read ranges for " << parameters.size() << " parameters" << endl;
  return 1;
  
}  // Map::init_parameter_ranges


