//
// $Id$
//

#ifndef __Map_2d_2d_Persp_h
#define __Map_2d_2d_Persp_h

#include <vector>
#include "Map.h"
#include "data_types/PointSet2D.h"





class Map_2d_2d_Persp : public Map
{

public:

  Map_2d_2d_Persp();

  void operator()(const PointSet2D& source, PointSet2D& result);
  void operator()(const PointSet2D& source, PointSet2D& result,
		  const vector<double>& in_pars);

  string get_name() { return "2D Perspectivity"; }
  int get_nr_pars() { return 6; }
  string get_par_name(int index) { return par_names[index]; }

  
private:

  static string par_names[6];
  static double initial_ranges[12];
  
  
};  // Map_2d_2d_Persp class


#endif


