//
// $Id$
//

#include <iostream>
#include "data_types/Vector.h"
#include "data_types/Matrix.h"
#include "Map_2d_2d_Proj.h"

#define DEBUG(x)





//
// parameters here are those of a 2D to 2D perspective transform (6)
//
// tx ty d angle ux uy
// u is a 3D unit vector, so uz can be derived from ux and uy
//
void
Map_2d_2d_Proj::operator()(const PointSet2D& source, PointSet2D& result,
			    const vector<double>& parameters)
{
  Matrix M(parameters[0], parameters[1], parameters[2], 0.0,
	   parameters[3], parameters[4], parameters[5], 0.0,
	   parameters[6], parameters[7], 1.0, 0.0,
	   0.0, 0.0, 0.0, 1.0);
  
  //
  // transform source
  //
  int nr_points = source.get_nr_points();
  DEBUG(cout << "transforming " << nr_points << " points" << endl);
  result.clear();
  
  for(int i=0; i < nr_points; i++) {
    Vector P(source[i * 2], source[i * 2 + 1], 1.0);
    DEBUG(cout << "source: " << P << endl);
    
    Vector Q = M * P;
    assert(Q[Z] == 1.0);
    
    DEBUG(cout << "  after trans: " << Q << endl);

    result.add_point(Q[X], Q[Y]);
    
  }  // for

}  // Map_2d_2d_Proj::operator()


