//
// $Id: Map_2d_Aff.cc,v 1.3 2004/03/01 09:46:54 min Exp min $
//

#include <iostream>
#include <math.h>
#include <CGAL/Cartesian.h>
#include <CGAL/Aff_transformation_2.h>
#include "Map_2d_Aff.h"

typedef CGAL::Cartesian<double> Rep;
typedef CGAL::Point_2<Rep> Point;





//
// here we have assumptions about what transformation is
// represented by the parameters
//
void
Map_2d_Aff::operator()(const PointSet2D& source, PointSet2D& result,
		       const vector<double>& parameters)
{
  //  cout << "Map_2d_Aff::operator()" << endl;

  // create matrix
  double angle = parameters[0];
  double cosa = cos(angle);
  double sina = sin(angle);
  double tx = parameters[1];
  double ty = parameters[2];
  double sx = parameters[3];
  double sy = parameters[4];
  
  //   cout << "PointSet::transform, angle: " << angle
  //        << ", t(" << tx << ", " << ty << "), s(" << sx << ", " << sy << ")" << endl;
  
  CGAL::Aff_transformation_2< CGAL::Cartesian<double> > tr(sx * cosa, -sx * sina, tx,
							   sy * sina, sy * cosa, ty);

  // transform source
  int nr_points = source.get_nr_points();
  result.clear();
  Point Q;
  
  for(int i=0; i < nr_points; i++) {
    Point P(source[i * 2], source[i * 2 + 1]);
    Q = tr.transform(P);

    result.add_point(Q[X], Q[Y]);
    
  }  // for
  
}  // Map_2d_Aff::operator()
