//
// $Id$
//

#include <iostream>
#include <math.h>
#include "data_types/Vector.h"
#include "data_types/Matrix.h"
#include "Map_2d_Sim.h"

#define DEBUG(x)





//
// parameters here are those of a 2D similarity transform
//
// tx ty angle s
//
void
Map_2d_Sim::operator()(const PointSet2D& source, PointSet2D& result,
		       const vector<double>& parameters)
{
  double tx = parameters[0];
  double ty = parameters[1];
  double angle = parameters[2];
  double scale = parameters[3];
  
  double cosa = cos(angle);
  double sina = sin(angle);
  
  Matrix M(scale * cosa, -scale * sina, tx,
	   scale * sina, scale * cosa, ty,
	   0.0, 0.0, 1.0);

  //
  // transform source
  //
  int nr_points = source.get_nr_points();
  DEBUG(cout << "transforming " << nr_points << " points" << endl);
  result.clear();
  
  for(int i=0; i < nr_points; i++) {
    Vector P(source[i * 2], source[i * 2 + 1]);
    DEBUG(cout << "source: " << P << endl);
    
    Vector Q = M * P;
    DEBUG(cout << "  after trans: " << Q << endl);

    result.add_point(Q[X], Q[Y]);
    
  }  // for

}  // Map_2d_Sim::operator()


