//
// $Id: Map_3d_Proj.h,v 1.1 2004/03/01 09:47:00 min Exp min $
//

#ifndef __Map_3d_Proj_h
#define __Map_3d_Proj_h

#include <vector>
#include "data_types/Vector.h"
#include "data_types/Matrix.h"
#include "data_types/PointSet2D.h"
#include "data_types/PointSet3D.h"

using namespace std;





class Map_3d_Proj
{

public:

  Map_3d_Proj() {}

  void operator()(const PointSet3D& source, PointSet2D& result,
		  const vector<double>& parameters);
  
  void set_camera(Vector pos, Vector lookat, Vector up, float viewplane_dist);

  
private:

  Vector pos, lookat, up;
  float viewplane_dist;

  Matrix modelview;
  void compute_modelview_matrix();

  Matrix projection;
  void compute_projection_matrix();
  
  
};  // Map_3d_Proj class


#endif


