//
// $Id: evo_traits_2d_iso_avg_hausdorff.h,v 1.5 2004/03/01 09:47:00 min Exp min $
//

#ifndef __EVO_TRAITS_2D_ISO_AVG_HAUSDORFF_H
#define __EVO_TRAITS_2D_ISO_AVG_HAUSDORFF_H

#include "data_types/PointSet2D.h"
#include "map_functions/Map_2d_Iso.h"
#include "error_functions/Avg_Hausdorff.h"





class evo_traits_2d_iso_avg_hausdorff
{

public:

  typedef class PointSet2D SourceType;
  typedef class PointSet2D TransformedSourceType;
  typedef class PointSet2D TargetType;

  typedef class Map_2d_Iso MapType;
  typedef class Avg_Hausdorff ErrorType;


  Map_2d_Iso&
  map_object() const
  {
    return (Map_2d_Iso&) map;
  }

  Avg_Hausdorff&
  error_object() const
  {
    return (Avg_Hausdorff&) error;
  }

  
private:

  Map_2d_Iso map;
  Avg_Hausdorff error;

  
};  // evo_traits_2d_iso_avg_hausdorff class


#endif
