//
// $Id: evo_traits_3d_proj_avg_hausdorff.h,v 1.1 2004/03/01 09:47:00 min Exp min $
//

#ifndef __EVO_TRAITS_H
#define __EVO_TRAITS_H

#include "PointSet3D.h"
#include "Map_3d_Proj.h"
#include "Avg_Hausdorff.h"





/// \brief instance of traits class for GenOpt
///
/// This instance uses PointSet3D as the source and target type,
/// a 3D affine transformation (using the CGAL library) as the map function,
/// and the "average Hausdorff" (or rather, the average minimum Hausdorff)
/// distance as the error function.
///
class evo_traits
{

public:

  typedef class PointSet3D SourceType;
  typedef class PointSet2D TransformedSourceType;
  typedef class PointSet2D TargetType;

  typedef class Map_3d_Proj MapType;
  typedef class Avg_Hausdorff ErrorType;


  Map_3d_Proj
  map_object() const
  {
    return map;
  }

  Avg_Hausdorff
  error_object() const
  {
    return error;
  }

  
private:

  Map_3d_Proj map;
  Avg_Hausdorff error;

  
};  // evo_traits class


#endif
